# Receive events from 24224/tcp
<source efk.*>
  @type forward
  port 24224
  bind 0.0.0.0
  # tag new_tag     # tag can be replaced here
</source>

# needs plugin multi-format-parser
<filter efk.server>
  @type parser
  key_name log
  <parse>
    @type multi_format
    <pattern>
      format regexp
      expression /^(?<host>[^ ]*)\s\-\s\- \[(?<datetime>[\d{1,2}\/[a-zA-Z]{3}\/\d{4}\s\d{2}\:\d{2}\:\d{2}]*)\] \"(?<method>[(GET|PUT|POST|DELETE)]*) (?<path>[^ ]*) (?<protocol>[^ ]*)\" (?<status>[^/d{3}]*)\s\-$/
    </pattern>
    <pattern>
      format regexp
      expression /^(?<host>[^ ]*)\s\-\s\- \[(?<datetime>[\d{1,2}\/[a-zA-Z]{3}\/\d{4}\s\d{2}\:\d{2}\:\d{2}]*)\] code (?<status>[\d{3}]*), (?<message>[^$]*)$/
    </pattern>
    <pattern>
      format none
    </pattern>
  </parse>
</filter>


# send to elasticsearch (additional plugin needed)
<match efk.*>
  @type elasticsearch
  host elasticsearch
  port 9200
  logstash_format true
  logstash_prefix fluentd.${tag}
  logstash_prefix_separator _
  <buffer> 
    flush_interval 5s
    flush_thread_count 2
  </buffer>
</match>
